﻿Type=Class
Version=3.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Private Sub Class_Globals
	'Dummy
	Dim ProjectionMatrix As Int
	Private cvs As Canvas	
End Sub

'Dummy Sub
Public Sub Initialize(lgCanvas As Canvas)
	cvs = lgCanvas
End Sub

'Dummy Sub
Public Sub Begin
End Sub

'Dummy Sub
Public Sub End
End Sub

'Dummy Sub
Public Sub dispose
End Sub

'Draws a rectangle with the bottom left corner at X,Y having the width And height of the region.
'X: The x-coordinate in screen space
'Y: The y-coordinate in screen space
Public Sub DrawRegion(Region As lgTextureRegion, X As Float, Y As Float)
	Dim img As GameViewHelper
	Dim src As Rect
	Dim dst As Rect
	src.Width  = Region.RegionWidth
	src.Height = Region.RegionHeight
	src.Left   = Region.RegionX
	src.Top    = Region.RegionY
	dst.Width  = Region.Texture.Width
	dst.Height = Region.Texture.Height
	dst.Left   = X
	If ProjectionMatrix = 1 Then
		dst.Top = Y
	Else
		dst.Top = (cvs.Height - dst.Height) - Y
	End If	
	img.DrawImageRotateAndFlipped(cvs, Region.Texture.InternalObject, src, dst, 0, FlipControl(Region.FlipValue))
End Sub

'Draws a rectangle with the bottom left corner at X,Y and stretching the region to cover the given width and height.
'X: The x-coordinate in screen space
'Y: The y-coordinate in screen space
Public Sub DrawRegion2(Region As lgTextureRegion, X As Float, Y As Float, Width As Float, Height As Float)
	Dim img As GameViewHelper
	Dim src As Rect
	Dim dst As Rect
	src.Width   = Region.RegionWidth
	src.Height  = Region.RegionHeight
	src.Left    = Region.RegionX
	src.Top     = Region.RegionY
	dst.Width   = Width
	dst.Height  = Height	
	dst.Left    = X
	If ProjectionMatrix = 1 Then
		dst.Top = Y
		'Region.FlipValue = FlipControl(Region.FlipValue)
	Else
		dst.Top = (cvs.Height - dst.Height) - Y
	End If	
	img.DrawImageRotateAndFlipped(cvs, Region.Texture.InternalObject, src, dst, 0, FlipControl(Region.FlipValue))
End Sub

'Draws a rectangle with the bottom left corner at X,Y and stretching the region to cover the given width and height.
'Origin and Scale are both dummy values.
'X: The x-coordinate in screen space
'Y: The y-coordinate in screen space
Public Sub DrawRegion3 (Region As lgTextureRegion, X As Float, Y As Float, originX As Float, originY As Float, Width As Float, Height As Float, scaleX As Float, scaleY As Float, Rotation As Float)
	Dim img As GameViewHelper
	Dim src As Rect
	Dim dst As Rect
	src.Width   = Region.RegionWidth
	src.Height  = Region.RegionHeight
	src.Left    = Region.RegionX
	src.Top     = Region.RegionY
	dst.Width   = Width
	dst.Height  = Height	
	dst.Left    = X
	If ProjectionMatrix = 1 Then
		dst.Top = Y
	Else
		dst.Top = (cvs.Height - dst.Height) - Y
	End If	
	img.DrawImageRotateAndFlipped(cvs, Region.Texture.InternalObject, src, dst, Rotation, FlipControl(Region.FlipValue))
End Sub

Private Sub FlipControl(FlipValue As Int) As Int
	If FlipValue = 0 Then
		Return 1
	else if FlipValue = 1 Then
		Return 0
	else if FlipValue = 3 Then
		Return 2
	else if FlipValue = 2 Then
		Return 2
	Else
		Return 0	
	End If
End Sub