﻿Type=Class
Version=3.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Private Sub Class_Globals	
	Dim RegionX      As Int
	Dim RegionY      As Int
	Dim RegionWidth  As Int
	Dim RegionHeight As Int	
	Dim Texture 	 As lgTexture	
	Dim IsFlipX      As Boolean
	Dim IsFlipY      As Boolean	
	Dim FlipValue    As Int
End Sub

'Constructs a region with no texture and no coordinates defined.
Public Sub Initialize
	RegionX      = 0
	RegionY      = 0
	RegionWidth  = 0
	RegionHeight = 0
	FlipValue    = 0	
End Sub

'Constructs a region the size of the specified texture.
Public Sub InitializeWithTexture(TextureName As lgTexture)
	Texture      = TextureName
	RegionX      = 0
	RegionY      = 0
	RegionWidth  = Texture.Width
	RegionHeight = Texture.Height
	FlipValue    = 0
End Sub

'Constructs a region with the specified texture.
'Width: The width of the texture region. May be negative To flip the sprite when drawn.
'Height: The height of the texture region. May be negative To flip the sprite when drawn.
Public Sub InitializeWithTexture2(TextureName As lgTexture, Width As Int, Height As Int)
	Texture      = TextureName
	RegionX      = 0
	RegionY      = 0
	RegionWidth  = Width
	RegionHeight = Height
	FlipValue    = 0
End Sub

'Constructs a region with the specified texture.
'Width: The width of the texture region. May be negative To flip the sprite when drawn.
'Height: The height of the texture region. May be negative To flip the sprite when drawn.
Public Sub InitializeWithTexture3(TextureName As lgTexture, X As Int, Y As Int, Width As Int, Height As Int)
	Texture      = TextureName
	RegionX      = X
	RegionY      = Y
	RegionWidth  = Width
	RegionHeight = Height
	FlipValue    = 0
End Sub

Public Sub SetRegion(X As Int, Y As Int, Width As Int, Height As Int)
	RegionX      = X
	RegionY      = Y
	RegionWidth  = Width
	RegionHeight = Height	
End Sub

Public Sub Flip(X As Boolean, Y As Boolean)
	IsFlipX = X
	IsFlipY = Y	
	If Not(X) And Not(Y) Then
		FlipValue = 0
	Else If Y And Not(X) Then
		FlipValue = 1
	Else If X And Not(Y) Then
		FlipValue = 2
	Else
		FlipValue = 3
	End If
End Sub